; RC4 cypher
;	(c) 2008, cod
;		cod@inbox.com

BITS 32
CPU 386

SECTION '.text'

;sbox	db 000h, 001h, 002h, 003h, 004h, 005h, 006h, 007h
;		db 008h, 009h, 00ah, 00bh, 00ch, 00dh, 00eh, 00fh
;		db 010h, 011h, 012h, 013h, 014h, 015h, 016h, 017h
;		db 018h, 019h, 01ah, 01bh, 01ch, 01dh, 01eh, 01fh
;		db 020h, 021h, 022h, 023h, 024h, 025h, 026h, 027h
;		db 028h, 029h, 02ah, 02bh, 02ch, 02dh, 02eh, 02fh
;		db 030h, 031h, 032h, 033h, 034h, 035h, 036h, 037h
;		db 038h, 039h, 03ah, 03bh, 03ch, 03dh, 03eh, 03fh
;		db 040h, 041h, 042h, 043h, 044h, 045h, 046h, 047h
;		db 048h, 049h, 04ah, 04bh, 04ch, 04dh, 04eh, 04fh
;		db 050h, 051h, 052h, 053h, 054h, 055h, 056h, 057h
;		db 058h, 059h, 05ah, 05bh, 05ch, 05dh, 05eh, 05fh
;		db 060h, 061h, 062h, 063h, 064h, 065h, 066h, 067h
;		db 068h, 069h, 06ah, 06bh, 06ch, 06dh, 06eh, 06fh
;		db 070h, 071h, 072h, 073h, 074h, 075h, 076h, 077h
;		db 078h, 079h, 07ah, 07bh, 07ch, 07dh, 07eh, 07fh
;		db 080h, 081h, 082h, 083h, 084h, 085h, 086h, 087h
;		db 088h, 089h, 08ah, 08bh, 08ch, 08dh, 08eh, 08fh
;		db 090h, 091h, 092h, 093h, 094h, 095h, 096h, 097h
;		db 098h, 099h, 09ah, 09bh, 09ch, 09dh, 09eh, 09fh
;		db 0a0h, 0a1h, 0a2h, 0a3h, 0a4h, 0a5h, 0a6h, 0a7h
;		db 0a8h, 0a9h, 0aah, 0abh, 0ach, 0adh, 0aeh, 0afh
;		db 0b0h, 0b1h, 0b2h, 0b3h, 0b4h, 0b5h, 0b6h, 0b7h
;		db 0b8h, 0b9h, 0bah, 0bbh, 0bch, 0bdh, 0beh, 0bfh
;		db 0c0h, 0c1h, 0c2h, 0c3h, 0c4h, 0c5h, 0c6h, 0c7h
;		db 0c8h, 0c9h, 0cah, 0cbh, 0cch, 0cdh, 0ceh, 0cfh
;		db 0d0h, 0d1h, 0d2h, 0d3h, 0d4h, 0d5h, 0d6h, 0d7h
;		db 0d8h, 0d9h, 0dah, 0dbh, 0dch, 0ddh, 0deh, 0dfh
;		db 0e0h, 0e1h, 0e2h, 0e3h, 0e4h, 0e5h, 0e6h, 0e7h
;		db 0e8h, 0e9h, 0eah, 0ebh, 0ech, 0edh, 0eeh, 0efh
;		db 0f0h, 0f1h, 0f2h, 0f3h, 0f4h, 0f5h, 0f6h, 0f7h
;		db 0f8h, 0f9h, 0fah, 0fbh, 0fch, 0fdh, 0feh, 0ffh
		
entry_point:
	dd		init_sbox
	dd		cypher_msg
	dd		decipher_sections
	dd		decipher_block
	dd		0

swap_byte:
	push	eax
	push	esi
	push	edi
	
	mov		esi, dword [esp+10h]
	mov		edi, dword [esp+14h]
	
	mov		al, byte [esi]
	mov		ah, byte [edi]
	mov		byte [edi], al
	mov		byte [esi], ah
	
	pop		edi
	pop		esi
	pop		eax
	
	ret		08h
	
init_sbox:
	push	ecx
	push	edi
	push	eax
	
	mov		ecx, 100h
	xor		eax, eax
	mov		edi, dword [esp+10h]
	
@@1:
	mov		byte [edi], al
	inc		edi
	inc		al
	loop	@@1
	
	pop		eax
	pop		edi
	pop		ecx
	ret		04h

; void init_sbox_key(unsigned char *key, int length)
; {
;	int j = 0;
;	for(int i=0; i < 256; i++) {
;		j = ( j + S[i] + key[i % length]) % 256;
;		SWAP(S[i], S[j]);
;	}
; }
	
	; EBP+08 = SBOX
	; EBP+0C = KEY
	; EBP+10 = LENGTH
init_sbox_key:
	push	ebp
	mov		ebp, esp
	push	ecx
	push	esi
	push	edi
	push	edx
	push	ebx
		
	xor		ecx, ecx	
	xor		eax, eax
	xor		ebx, ebx				; J
	
	mov		esi, dword [ebp+0ch]	; 00000000h
	mov		edi, dword [ebp+08h]	; EDI

init_sbox_key_for:	
	cmp		ecx, 100h
	jnb		init_sbox_key_end

	movzx	eax, byte [edi+ecx]		; S[i]
	add		ebx, eax				; j + S[i]
	
	; i % length
	mov		eax, ecx				; EAX = i
	xor		edx, edx
	idiv	dword [ebp+10h]			; i % LENGTH
		
	movzx	eax, byte [esi+edx]		; 
	
	add		ebx, eax				; key[i%length] + S[i]
	and		ebx, 0ffh				; j = j % 256

	; swap(&s[i], &s[j])	
	mov		eax, edi
	add		eax, ebx
	push	eax						; SBOX[j]
	mov		eax, edi
	add		eax, ecx				; SBOX[i]
	push	eax
	call	swap_byte
	
	inc		ecx
	
	jmp		init_sbox_key_for
	
init_sbox_key_end:
	pop		ebx
	pop		edx
	pop		edi
	pop		esi
	pop		ecx
	
	mov		esp, ebp
	pop		ebp
	ret		0ch

	;	EBP+08
	;	EBP+0C
	;	EBP+10
	;	EBP+14
cypher_msg:
	push	ebp
	mov		ebp, esp
	
	sub		esp, 20h
	push	esi
	push	edi
	push	edx
	
	mov		edi, dword [ebp+10h]
	xor		eax, eax
	
	mov		dword [ebp-04h], eax		; i = 0
	mov		dword [ebp-08h], eax		; j = 0
	mov		dword [ebp-0ch], eax		; n = 0
	
	mov		esi, dword [ebp+08h]		; esi = msg
	mov		ecx, dword [ebp+0ch]		; ecx = length
	test	ecx, ecx
	jz		end_cypher_msg

cypher_char:
	mov		eax, dword [ebp-04h]		; eax = i
	inc		eax
	and		eax, 0ffh					; eax = i%256
	mov		dword [ebp-04h], eax		; i = (i+1) % 256
	mov		[ebp-0ch],	eax
	movzx	eax, byte [edi+eax]			; S[i]
	add		eax, dword [ebp-08h]		; S[i] + j
	and		eax, 0ffh					; (S[i] + j) % 256
	mov		dword [ebp-08h], eax		; J = (J + S[i]) % 256
	
	; SWAP
	push	dword [ebp-08h]
	push	dword [ebp-04h]
	add		dword [esp], edi
	add		dword [esp+4], edi
	call	swap_byte
	
	mov		edx, dword [ebp-04h]		; i
	movzx	eax, byte [edi+edx]			; S[i]
	mov		edx, dword [ebp-08h]		; j
	push	eax
	movzx	eax, byte [edi+edx]			; S[j]
	add		dword [esp], eax
	pop		eax							; EAX = S[j] + S[i]
	and		eax, 0ffh
	movzx	eax, byte [edi+eax]			; EAX = S[S[j] + S[i] % 256]
	xor		byte [esi], al				; msg[n] ^= al
	
	inc		esi
	loop	cypher_char
	
end_cypher_msg:
	pop		edx
	pop		edi
	pop		esi
	
	mov		esp, ebp
	pop		ebp
	ret		0ch

end_text_block:

; ************************************************************************

; DECIPHER BLOCK!
	; EBP+08	base addr.
	; EBP+0C	cipher block
	; EBP+10	key
	; EBP+14	key length
	
decipher_sections:
	;int		03
	push	ebp
	mov		ebp, esp
	
	push	esi
	push	eax

	push	dword [ebp+14h]			; LENGTH!
	push	dword [ebp+10h]			; KEY!
	push	dword [ebp+0ch]			; SBOX
	call	init_sbox_key
	
	mov		esi, dword [ebp+08h]	; ESI = MZ
	mov		eax, dword [esi+3ch]
	add		esi, eax				; ESI = PE
	movzx	ecx, word [esi+06h]		; No. of sections
	movzx	eax, word [esi+14h]		; EAX = size of PE
	add		eax, 18h				; EAX = first section!
	add		esi, eax				; ESI = first section data

_scan_section:
	test	ecx, ecx
	jz		end_decipher_sections

	push	dword [ebp+0ch]			; cipher sbox!
	mov		eax, dword [ebp+08h]
	add		eax, dword [esi+0ch]	;
	push	dword [esi+08h]			; size
	push	eax						; address
	call	cypher_msg
	xor		eax, eax
	
	add		esi, 28h
	dec		ecx
	jmp		_scan_section
		
end_decipher_sections:
	pop		ecx
	pop		eax
	pop		esi
	mov		esp, ebp
	pop		ebp
	ret		10h

; DECIPHER BLOCK!
	; EBP+08	msg
	; EBP+0C	cipher block
	; EBP+10	key
	; EBP+14	key length
	; EBP+18	msg length
decipher_block:
	;int		03

	push	ebp
	mov		ebp, esp
	
	push	esi
	push	eax

	push	dword [ebp+14h]			; LENGTH!
	push	dword [ebp+10h]			; KEY!
	push	dword [ebp+0ch]			; SBOX
	call	init_sbox_key
	
	mov		esi, dword [ebp+08h]	; ESI = MZ

	push	dword [ebp+0ch]		; length
	push	dword [ebp+18h]		; block
	push	dword [ebp+08h]		; sbox!
	call	cypher_msg
	xor		eax, eax
	
	pop		eax
	pop		esi
	mov		esp, ebp
	pop		ebp
	ret		14h